"""these tests are here to create some :class:`tiramisu.option.Option`'s
and to compare them
"""
import autopath
from py.test import raises

from tiramisu.option import BoolOption, IntOption


#def test_option_comparison():
#    "compare :class:`tiramisu.option.BoolOption`"
#    dummy1 = BoolOption('dummy1', 'doc dummy')
#    dummy2 = BoolOption('dummy2', 'doc dummy')
#    dummy3 = BoolOption('dummy1', 'doc dummy')
#    assert dummy1 != dummy2
#    assert dummy1 == dummy3


#def test_option_comparison_obj():
#    "compare :class:`tiramisu.option.IntOption`"
#    dummy1 = BoolOption('dummy1', 'doc dummy')
#    dummy2 = IntOption('dummy1', 'doc dummy')
#    assert dummy1 != dummy2


#def test_option_comparison_advanced():
#    dummy1 = BoolOption('dummy1', 'doc dummy')
#    dummy2 = BoolOption('dummy1', 'doc dummy')
#    dummy3 = BoolOption('dummy1', 'doc dummy', None)
#    dummy4 = BoolOption('dummy1', 'doc dummy', True)
#    dummy5 = BoolOption('dummy1', 'doc dummy', multi=True)
#    dummy6 = BoolOption('dummy1', 'doc dummy', properties=tuple())
#    dummy7 = BoolOption('dummy1', 'doc dummy', properties=tuple('new',))
#    assert dummy1 == dummy2
#    assert dummy1 == dummy3
#    assert dummy1 != dummy4
#    assert dummy1 != dummy5
#    assert dummy1 == dummy6
#    assert dummy1 != dummy7


def test_option_valid_name():
    IntOption('test', '')
    raises(ValueError, 'IntOption(1, "")')
    raises(ValueError, 'IntOption("impl_test", "")')
    raises(ValueError, 'IntOption("_test", "")')
    raises(ValueError, 'IntOption("unwrap_from_path", "")')


def test_option_get_information():
    i = IntOption('test', '')
    string = 'some informations'
    i.impl_set_information('info', string)
    assert i.impl_get_information('info') == string
    raises(ValueError, "i.impl_get_information('noinfo')")
    assert i.impl_get_information('noinfo', 'default') == 'default'

def test_option_multi():
    IntOption('test', '', multi=True)
    IntOption('test', '', multi=True, default_multi=1)
    IntOption('test', '', default=[1], multi=True, default_multi=1)
    raises(ValueError, "IntOption('test', '', default_multi=1)")
